    AXYBOT
     ARDUINO ,     (ArduinoUNO),     (ArduinoNANO).    NRF24L01     ()     nRF24L01+,     ISM 2.4-2.5 ,      .   MPU6050     ,         X  Y.    nRF24L01+      .      nRF24L01+         MPU6050. 


  ( ).

#include "I2Cdev.h"
#include "MPU6050.h"
#include <SPI.h>  //      SPI-
#include <nRF24L01.h> //      RF24
#include <RF24.h> //         NRF24L01
RF24 radio(9, 10); // ""    9  10  
byte address[][6] = {"1Node", "2Node", "3Node", "4Node", "5Node", "6Node"}; //  
#define PIN_POT A0  //   Arduino,    
#define TO_DEG 57.2957f
#define TIME_OUT 20
MPU6050 accgyro;
; //   radio    CE  CSN
int accuracy = 30; // 
float anglex;
float angley;
long int t1;
void setup() {
  Serial.begin(115200);         //      
  accgyro.initialize(); //  
  radio.begin();              //  
  radio.setAutoAck(1);        //   , 1  0 
  radio.setRetries(0, 15);    // (   ,  )
  radio.enableAckPayload();   //        
  radio.setPayloadSize(32);   //  ,  
  radio.openWritingPipe(address[0]);  //  -  0,     
  radio.setChannel(0x60);             //   (   !)
  radio.setPALevel (RF24_PA_MAX);   //   .   RF24_PA_MIN, RF24_PA_LOW, RF24_PA_HIGH, RF24_PA_MAX
  radio.setDataRate (RF24_250KBPS); //  .   RF24_2MBPS, RF24_1MBPS, RF24_250KBPS
  //      !
  //         !!

  radio.powerUp();        //  
  radio.stopListening();  //   ,  
}
void loop() {
  long int t = millis();
  if(t1 < t) {
    int16_t ax, ay, az, gx, gy, gz;
    float accx, accy,gyrox;
    t1 = t + TIME_OUT;
    accgyro.getMotion6(&ax, &ay, &az, &gx, &gy, &gz);
    //       1G = 4096
    accx = ax/4096.0;
    accy = ay/4096.0;
    //   -1G  +1G
    accx = constrain(accx, -1.0, 1.0);
    accy = constrain(accy, -1.0, 1.0);
    //    
    if(accy >= 0){
      anglex = 90 - TO_DEG*acos(accy);
    } else {
      anglex = TO_DEG*acos(-accy) - 90;
    }
    if(accx >= 0){
      angley = 90 - TO_DEG*acos(accx);
    } else {
      angley = TO_DEG*acos(-accx) - 90;
    }
    int x = angley;
    int y = anglex;
    int direct[2];
        if(x < accuracy && x > -accuracy) {
      if(y < accuracy && y > -accuracy) {
        direct[0] = 0;//STOP    
      } else if(y > accuracy) {
        direct[0] = 2;//
      } else if(y < -accuracy) {
        direct[0] = 1; //
      }   
    } else if( x > accuracy) {
      //
      if(y < accuracy && y > -accuracy) {
        direct[0] = 6;//    
      } else if(y > accuracy) {
        direct[0] = 8;//  
      } else if(y < -accuracy) {
        direct[0] = 7; //  
      }   
    } else if(x < -accuracy) {
      //
      if(y < accuracy && y > -accuracy) {
        direct[0] = 3;//    
      } else if(y > accuracy) {
        direct[0] = 5;//  
      } else if(y < -accuracy) {
        direct[0] = 4; //  
      }   
    }
    int speed = max(abs(x), abs(y));
    if(speed > accuracy) {
      direct[1] = map(speed, accuracy, 90, 30, 100);
      Serial.println();
      Serial.print("Type:");
      Serial.print(direct[0]);
      Serial.print("X:");
      Serial.print(anglex,0);
      Serial.print(" ");
      Serial.print("Y:");
      Serial.print(angley,0);
      Serial.println(" ");
    } else {
      direct[1] = 0;
    }
        radio.write(direct, sizeof(direct)); //    
  }
}



















  AXYBOT (     ).

#include <SPI.h>  //      SPI-
#include <SparkFun_TB6612.h>
#include <nRF24L01.h> //      RF24
#include <RF24.h> //         NRF24L01
#define PIN_LED 3  //   Arduino,    
#define PWMA 5
#define AIN1 3
#define AIN2 4
#define BIN1 8
#define BIN2 7
#define PWMB 6
#define STBY 14 //(A0)
RF24 radio(9, 10); //   radio    CE  CSN
byte address[][6] = {"1Node", "2Node", "3Node", "4Node", "5Node", "6Node"}; //  
int potValue[2]; //     
const int offsetA = 1;
const int offsetB = 1;
Motor motor1 = Motor(AIN1, AIN2, PWMA, offsetA, STBY);
Motor motor2 = Motor(BIN1, BIN2, PWMB, offsetB, STBY);
void setup() {
  Serial.begin(9600);         //      
  radio.begin();              //  
  radio.setAutoAck(1);        //   , 1  0 
  radio.setRetries(0, 15);    // (   ,  )
  radio.enableAckPayload();   //        
  radio.setPayloadSize(32);   //  ,  

  radio.openReadingPipe(1, address[0]);   //    0
  radio.setChannel(0x60);     //   (   !)

  radio.setPALevel (RF24_PA_MAX);   //   .   RF24_PA_MIN, RF24_PA_LOW, RF24_PA_HIGH, RF24_PA_MAX
  radio.setDataRate (RF24_250KBPS); //  .   RF24_2MBPS, RF24_1MBPS, RF24_250KBPS
  //      !
  //         !!

  radio.powerUp();        //  
  radio.startListening(); //   ,   
}
void loop() {
  if(radio.available()){ //      
    radio.read(&potValue, sizeof(potValue)); //   
    int direct = potValue[0];
    int speedd = map(potValue[1], 0, 100, 0, 255);
    switch (direct){
        case 0://
          motor1.drive(speedd);
          motor2.drive(speedd);
          break;
        case 1://
          motor1.drive(-speedd);
          motor2.drive(speedd);
          break;
        case 2://
          motor1.drive(speedd);
          motor2.drive(-speedd);
          break;
        case 3://
          motor1.drive(speedd);
          motor2.drive(speedd);
          break;
        case 4://  
          motor1.drive(speedd * 0.5);
          motor2.drive(speedd);
          break;
        case 5://  
          motor1.drive(speedd);
          motor2.drive(speedd * 0.5);
          break;
        case 6://
          motor1.drive(-speedd);
          motor2.drive(-speedd);
          break;
        case 7://  
          motor1.drive(-speedd * 0.5);
          motor2.drive(-speedd);
          break;
        case 8://  
          motor1.drive(-speedd);
          motor2.drive(-speedd * 0.5);
          break;
      }
  }

}

